Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 1319)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -85,34 +91,4 @@
 ! dimension.
 !
-! 743 2011-08-18 16:10:16Z suehring
-! Evaluation of turbulent fluxes with WS-scheme only for the whole model 
-! domain. Therefor dimension of arrays needed for statistical evaluation 
-! decreased.
-!
-! 736 2011-08-17 14:13:26Z suehring 
-! Bugfix concerning OpenMP parallelization. i_omp introduced, because first
-! index where fluxes on left side have to be calculated explicitly is 
-! different on each thread. Furthermore the swapping of fluxes is now 
-! thread-safe by adding an additional dimension.
-!
-! 713 2011-03-30 14:21:21Z suehring
-! File reformatted.
-! Bugfix in vertical advection of w concerning the optimized version for   
-! vector architecture.
-! Constants adv_mom_3, adv_mom_5, adv_sca_5, adv_sca_3 reformulated as
-! broken numbers.
-!
-! 709 2011-03-30 09:31:40Z raasch
-! formatting adjustments
-!
-! 705 2011-03-25 11:21:43 Z suehring $
-! Bugfix in declaration of logicals concerning outflow boundaries.
-! 
-! 411 2009-12-11 12:31:43 Z suehring 
-! Allocation of weight_substep moved to init_3d_model. 
-! Declaration of ws_scheme_sca and ws_scheme_mom moved to check_parameters.
-! Setting bc for the horizontal velocity variances added (moved from 
-! flow_statistics).
-!
 ! Initial revision
 !
@@ -186,10 +162,31 @@
     SUBROUTINE ws_init
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE indices
+       USE arrays_3d,                                                          &
+           ONLY:  diss_l_e, diss_l_nr, diss_l_pt, diss_l_q, diss_l_qr,         &
+                  diss_l_sa, diss_l_u, diss_l_v, diss_l_w,  flux_l_e,          &
+                  flux_l_nr, flux_l_pt, flux_l_q, flux_l_qr, flux_l_sa,        &
+                  flux_l_u, flux_l_v, flux_l_w, diss_s_e, diss_s_nr, diss_s_pt,&
+                  diss_s_q, diss_s_qr, diss_s_sa, diss_s_u, diss_s_v, diss_s_w,& 
+                  flux_s_e, flux_s_nr, flux_s_pt, flux_s_q, flux_s_qr,         &
+                  flux_s_sa, flux_s_u, flux_s_v, flux_s_w
+
+       USE constants,                                                          &
+           ONLY:  adv_mom_1, adv_mom_3, adv_mom_5, adv_sca_1, adv_sca_3,       &
+                  adv_sca_5
+
+       USE control_parameters,                                                 &
+           ONLY:  cloud_physics, humidity, icloud_scheme, loop_optimization,   &
+                  passive_scalar, precipitation, ocean, ws_scheme_mom,         &
+                  ws_scheme_sca
+
+       USE indices,                                                            &
+           ONLY:  nyn, nys, nzb, nzt  
+       
        USE pegrid
-       USE statistics
+
+       USE statistics,                                                         &
+           ONLY:  sums_us2_ws_l, sums_vs2_ws_l, sums_ws2_ws_l, sums_wsnrs_ws_l,&
+                  sums_wspts_ws_l, sums_wsqrs_ws_l, sums_wsqs_ws_l,            &
+                  sums_wssas_ws_l,  sums_wsus_ws_l, sums_wsvs_ws_l  
 
 !
@@ -205,8 +202,8 @@
        IF ( ws_scheme_mom )  THEN
 
-          ALLOCATE( sums_wsus_ws_l(nzb:nzt+1,0:threads_per_task-1),  &
-                    sums_wsvs_ws_l(nzb:nzt+1,0:threads_per_task-1),  &
-                    sums_us2_ws_l(nzb:nzt+1,0:threads_per_task-1),   &
-                    sums_vs2_ws_l(nzb:nzt+1,0:threads_per_task-1),   &
+          ALLOCATE( sums_wsus_ws_l(nzb:nzt+1,0:threads_per_task-1),            &
+                    sums_wsvs_ws_l(nzb:nzt+1,0:threads_per_task-1),            &
+                    sums_us2_ws_l(nzb:nzt+1,0:threads_per_task-1),             &
+                    sums_vs2_ws_l(nzb:nzt+1,0:threads_per_task-1),             &
                     sums_ws2_ws_l(nzb:nzt+1,0:threads_per_task-1) )
 
@@ -229,5 +226,5 @@
           ENDIF
 
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                 &
                precipitation )  THEN
              ALLOCATE( sums_wsqrs_ws_l(nzb:nzt+1,0:threads_per_task-1) )
@@ -253,15 +250,15 @@
           IF ( ws_scheme_mom )  THEN
 
-             ALLOCATE( flux_s_u(nzb+1:nzt,0:threads_per_task-1),            &
-                       flux_s_v(nzb+1:nzt,0:threads_per_task-1),            &
-                       flux_s_w(nzb+1:nzt,0:threads_per_task-1),            &
-                       diss_s_u(nzb+1:nzt,0:threads_per_task-1),            &
-                       diss_s_v(nzb+1:nzt,0:threads_per_task-1),            &
+             ALLOCATE( flux_s_u(nzb+1:nzt,0:threads_per_task-1),               &
+                       flux_s_v(nzb+1:nzt,0:threads_per_task-1),               &
+                       flux_s_w(nzb+1:nzt,0:threads_per_task-1),               &
+                       diss_s_u(nzb+1:nzt,0:threads_per_task-1),               &
+                       diss_s_v(nzb+1:nzt,0:threads_per_task-1),               &
                        diss_s_w(nzb+1:nzt,0:threads_per_task-1) )
-             ALLOCATE( flux_l_u(nzb+1:nzt,nys:nyn,0:threads_per_task-1),    &
-                       flux_l_v(nzb+1:nzt,nys:nyn,0:threads_per_task-1),    &
-                       flux_l_w(nzb+1:nzt,nys:nyn,0:threads_per_task-1),    &
-                       diss_l_u(nzb+1:nzt,nys:nyn,0:threads_per_task-1),    &
-                       diss_l_v(nzb+1:nzt,nys:nyn,0:threads_per_task-1),    &
+             ALLOCATE( flux_l_u(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
+                       flux_l_v(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
+                       flux_l_w(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
+                       diss_l_u(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
+                       diss_l_v(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
                        diss_l_w(nzb+1:nzt,nys:nyn,0:threads_per_task-1) )
 
@@ -270,36 +267,36 @@
           IF ( ws_scheme_sca )  THEN
 
-             ALLOCATE( flux_s_pt(nzb+1:nzt,0:threads_per_task-1),           &
-                       flux_s_e(nzb+1:nzt,0:threads_per_task-1),            &
-                       diss_s_pt(nzb+1:nzt,0:threads_per_task-1),           &
+             ALLOCATE( flux_s_pt(nzb+1:nzt,0:threads_per_task-1),              &
+                       flux_s_e(nzb+1:nzt,0:threads_per_task-1),               &
+                       diss_s_pt(nzb+1:nzt,0:threads_per_task-1),              &
                        diss_s_e(nzb+1:nzt,0:threads_per_task-1) ) 
-             ALLOCATE( flux_l_pt(nzb+1:nzt,nys:nyn,0:threads_per_task-1),   &
-                       flux_l_e(nzb+1:nzt,nys:nyn,0:threads_per_task-1),    &
-                       diss_l_pt(nzb+1:nzt,nys:nyn,0:threads_per_task-1),   &
+             ALLOCATE( flux_l_pt(nzb+1:nzt,nys:nyn,0:threads_per_task-1),      &
+                       flux_l_e(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
+                       diss_l_pt(nzb+1:nzt,nys:nyn,0:threads_per_task-1),      &
                        diss_l_e(nzb+1:nzt,nys:nyn,0:threads_per_task-1) )
 
              IF ( humidity  .OR.  passive_scalar )  THEN
-                ALLOCATE( flux_s_q(nzb+1:nzt,0:threads_per_task-1),          &
+                ALLOCATE( flux_s_q(nzb+1:nzt,0:threads_per_task-1),            &
                           diss_s_q(nzb+1:nzt,0:threads_per_task-1) )
-                ALLOCATE( flux_l_q(nzb+1:nzt,nys:nyn,0:threads_per_task-1),  &
+                ALLOCATE( flux_l_q(nzb+1:nzt,nys:nyn,0:threads_per_task-1),    &
                           diss_l_q(nzb+1:nzt,nys:nyn,0:threads_per_task-1) )
              ENDIF
 
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.            &
+             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
                   precipitation )  THEN
-                ALLOCATE( flux_s_qr(nzb+1:nzt,0:threads_per_task-1),         &
-                          diss_s_qr(nzb+1:nzt,0:threads_per_task-1),         &
-                          flux_s_nr(nzb+1:nzt,0:threads_per_task-1),         &
+                ALLOCATE( flux_s_qr(nzb+1:nzt,0:threads_per_task-1),           &
+                          diss_s_qr(nzb+1:nzt,0:threads_per_task-1),           &
+                          flux_s_nr(nzb+1:nzt,0:threads_per_task-1),           &
                           diss_s_nr(nzb+1:nzt,0:threads_per_task-1) )
-                ALLOCATE( flux_l_qr(nzb+1:nzt,nys:nyn,0:threads_per_task-1), &
-                          diss_l_qr(nzb+1:nzt,nys:nyn,0:threads_per_task-1), &
-                          flux_l_nr(nzb+1:nzt,nys:nyn,0:threads_per_task-1), &
+                ALLOCATE( flux_l_qr(nzb+1:nzt,nys:nyn,0:threads_per_task-1),   &
+                          diss_l_qr(nzb+1:nzt,nys:nyn,0:threads_per_task-1),   &
+                          flux_l_nr(nzb+1:nzt,nys:nyn,0:threads_per_task-1),   &
                           diss_l_nr(nzb+1:nzt,nys:nyn,0:threads_per_task-1) ) 
              ENDIF
 
              IF ( ocean )  THEN
-                ALLOCATE( flux_s_sa(nzb+1:nzt,0:threads_per_task-1),         &
+                ALLOCATE( flux_s_sa(nzb+1:nzt,0:threads_per_task-1),           &
                           diss_s_sa(nzb+1:nzt,0:threads_per_task-1) )
-                ALLOCATE( flux_l_sa(nzb+1:nzt,nys:nyn,0:threads_per_task-1), &
+                ALLOCATE( flux_l_sa(nzb+1:nzt,nys:nyn,0:threads_per_task-1),   &
                           diss_l_sa(nzb+1:nzt,nys:nyn,0:threads_per_task-1) )
              ENDIF
@@ -317,6 +314,12 @@
     SUBROUTINE ws_statistics
     
-       USE control_parameters
-       USE statistics
+       USE control_parameters,                                                 &
+           ONLY:  cloud_physics, humidity, icloud_scheme, passive_scalar,      &
+                  precipitation, ocean, ws_scheme_mom, ws_scheme_sca
+
+       USE statistics,                                                         &
+           ONLY:  sums_us2_ws_l, sums_vs2_ws_l, sums_ws2_ws_l, sums_wsnrs_ws_l,&
+                  sums_wspts_ws_l, sums_wsqrs_ws_l, sums_wsqs_ws_l,            &
+                  sums_wssas_ws_l,  sums_wsus_ws_l, sums_wsvs_ws_l  
 
        IMPLICIT NONE
@@ -336,5 +339,5 @@
           sums_wspts_ws_l = 0.0
           IF ( humidity  .OR.  passive_scalar )  sums_wsqs_ws_l = 0.0
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                 &
                precipitation )  THEN
              sums_wsqrs_ws_l = 0.0
@@ -351,34 +354,77 @@
 ! Scalar advection - Call for grid point i,j
 !------------------------------------------------------------------------------!
-    SUBROUTINE advec_s_ws_ij( i, j, sk, sk_char, swap_flux_y_local,  &
-                              swap_diss_y_local, swap_flux_x_local,  &
+    SUBROUTINE advec_s_ws_ij( i, j, sk, sk_char, swap_flux_y_local,            &
+                              swap_diss_y_local, swap_flux_x_local,            &
                               swap_diss_x_local, i_omp, tn )
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE grid_variables
-       USE indices
+       USE arrays_3d,                                                          &
+           ONLY:  ddzw, tend, u, v, w
+
+       USE constants,                                                          &
+           ONLY:  adv_sca_1, adv_sca_3, adv_sca_5
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans 
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzb_max, nzt, wall_flags_0
+
+       USE kinds
+
        USE pegrid
-       USE statistics
+
+       USE statistics,                                                         &
+           ONLY:  sums_wsnrs_ws_l, sums_wspts_ws_l, sums_wsqrs_ws_l,           &
+                  sums_wsqs_ws_l, sums_wssas_ws_l, weight_substep
 
        IMPLICIT NONE
 
-       INTEGER ::  i, ibit0, ibit1, ibit2, ibit3, ibit4, ibit5, ibit6,        &
-                   ibit7, ibit8, i_omp, j, k, k_mm, k_pp, k_ppp,  tn
-       REAL    ::  diss_d, div, flux_d, u_comp, v_comp
+       CHARACTER (LEN = *), INTENT(IN) ::  sk_char !:
+       
+       INTEGER(iwp) ::  i     !:
+       INTEGER(iwp) ::  ibit0 !:
+       INTEGER(iwp) ::  ibit1 !:
+       INTEGER(iwp) ::  ibit2 !:
+       INTEGER(iwp) ::  ibit3 !:
+       INTEGER(iwp) ::  ibit4 !:
+       INTEGER(iwp) ::  ibit5 !:
+       INTEGER(iwp) ::  ibit6 !:
+       INTEGER(iwp) ::  ibit7 !:
+       INTEGER(iwp) ::  ibit8 !:
+       INTEGER(iwp) ::  i_omp !:
+       INTEGER(iwp) ::  j     !:
+       INTEGER(iwp) ::  k     !:
+       INTEGER(iwp) ::  k_mm  !:
+       INTEGER(iwp) ::  k_pp  !:
+       INTEGER(iwp) ::  k_ppp !:
+       INTEGER(iwp) ::  tn    !:
+       
+       REAL(wp)     ::  diss_d !:
+       REAL(wp)     ::  div    !:
+       REAL(wp)     ::  flux_d !:
+       REAL(wp)     ::  u_comp !:
+       REAL(wp)     ::  v_comp !:
+       
 #if defined( __nopointer )
-       REAL, DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !:
 #else
-       REAL, DIMENSION(:,:,:), POINTER    ::  sk
+       REAL(wp), DIMENSION(:,:,:), POINTER    ::  sk     !:
 #endif
-       REAL, DIMENSION(nzb:nzt+1)         ::  diss_n, diss_r, diss_t, flux_n,  &
-                                              flux_r, flux_t
-       REAL, DIMENSION(nzb+1:nzt,0:threads_per_task-1) ::  swap_diss_y_local,  &
-                                                           swap_flux_y_local
-       REAL, DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) ::              &
-                                                          swap_diss_x_local,   &
-                                                          swap_flux_x_local
-       CHARACTER (LEN = *), INTENT(IN)    ::  sk_char
+       REAL(wp), DIMENSION(nzb:nzt+1)         ::  diss_n !:
+       REAL(wp), DIMENSION(nzb:nzt+1)         ::  diss_r !:
+       REAL(wp), DIMENSION(nzb:nzt+1)         ::  diss_t !:
+       REAL(wp), DIMENSION(nzb:nzt+1)         ::  flux_n !:
+       REAL(wp), DIMENSION(nzb:nzt+1)         ::  flux_r !:
+       REAL(wp), DIMENSION(nzb:nzt+1)         ::  flux_t !:
+       
+       REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1) ::  swap_diss_y_local !:
+       REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1) ::  swap_flux_y_local !:
+       
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) ::  swap_diss_x_local !:
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) ::  swap_flux_x_local !:
+       
 
 !
@@ -800,18 +846,60 @@
     SUBROUTINE advec_u_ws_ij( i, j, i_omp, tn )
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzw, diss_l_u, diss_s_u, flux_l_u, flux_s_u, tend, u, v, w
+
+       USE constants,                                                          &
+           ONLY:  adv_mom_1, adv_mom_3, adv_mom_5
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzb_max, nzt, wall_flags_0
+
+       USE kinds
+
+       USE statistics,                                                         &
+           ONLY:  hom, sums_us2_ws_l, sums_wsus_ws_l, weight_substep
 
        IMPLICIT NONE
 
-       INTEGER ::  i, ibit9, ibit10, ibit11, ibit12, ibit13, ibit14, ibit15,  &
-                   ibit16, ibit17, i_omp, j, k, k_mm, k_pp, k_ppp, tn
-       REAL    ::  diss_d, div, flux_d, gu, gv, u_comp_l, v_comp, w_comp
-       REAL, DIMENSION(nzb:nzt+1) :: diss_n, diss_r, diss_t, flux_n, flux_r,  &
-                                     flux_t, u_comp
+       INTEGER(iwp) ::  i      !:
+       INTEGER(iwp) ::  ibit9  !:
+       INTEGER(iwp) ::  ibit10 !:
+       INTEGER(iwp) ::  ibit11 !:
+       INTEGER(iwp) ::  ibit12 !:
+       INTEGER(iwp) ::  ibit13 !:
+       INTEGER(iwp) ::  ibit14 !:
+       INTEGER(iwp) ::  ibit15 !:
+       INTEGER(iwp) ::  ibit16 !:
+       INTEGER(iwp) ::  ibit17 !:
+       INTEGER(iwp) ::  i_omp  !:
+       INTEGER(iwp) ::  j      !:
+       INTEGER(iwp) ::  k      !:
+       INTEGER(iwp) ::  k_mm   !:
+       INTEGER(iwp) ::  k_pp   !:
+       INTEGER(iwp) ::  k_ppp  !:
+       INTEGER(iwp) ::  tn     !:
+       
+       REAL(wp)    ::  diss_d   !:
+       REAL(wp)    ::  div      !:
+       REAL(wp)    ::  flux_d   !:
+       REAL(wp)    ::  gu       !:
+       REAL(wp)    ::  gv       !:
+       REAL(wp)    ::  u_comp_l !:
+       REAL(wp)    ::  v_comp   !:
+       REAL(wp)    ::  w_comp   !:
+       
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  diss_n !:
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  diss_r !:
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  diss_t !:
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  flux_n !:
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  flux_r !:
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  flux_t !:
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  u_comp !:
 
        gu = 2.0 * u_gtrans
@@ -1212,18 +1300,60 @@
    SUBROUTINE advec_v_ws_ij( i, j, i_omp, tn )
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzw, diss_l_v, diss_s_v, flux_l_v, flux_s_v, tend, u, v, w
+
+       USE constants,                                                          &
+           ONLY:  adv_mom_1, adv_mom_3, adv_mom_5
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nyn, nys, nysv, nzb, nzb_max, nzt, wall_flags_0
+
+       USE kinds
+
+       USE statistics,                                                         &
+           ONLY:  hom, sums_vs2_ws_l, sums_wsvs_ws_l, weight_substep
 
        IMPLICIT NONE
 
-       INTEGER  ::  i, ibit18, ibit19, ibit20, ibit21, ibit22, ibit23, ibit24, &
-                    ibit25, ibit26, i_omp, j, k, k_mm, k_pp, k_ppp, tn
-       REAL     ::  diss_d, div, flux_d, gu, gv, u_comp, v_comp_l, w_comp
-       REAL, DIMENSION(nzb:nzt+1)  :: diss_n, diss_r, diss_t, flux_n, flux_r,  &
-                                      flux_t, v_comp
+       INTEGER(iwp)  ::  i      !:
+       INTEGER(iwp)  ::  ibit18 !:
+       INTEGER(iwp)  ::  ibit19 !:
+       INTEGER(iwp)  ::  ibit20 !:
+       INTEGER(iwp)  ::  ibit21 !:
+       INTEGER(iwp)  ::  ibit22 !:
+       INTEGER(iwp)  ::  ibit23 !:
+       INTEGER(iwp)  ::  ibit24 !:
+       INTEGER(iwp)  ::  ibit25 !:
+       INTEGER(iwp)  ::  ibit26 !:
+       INTEGER(iwp)  ::  i_omp  !:
+       INTEGER(iwp)  ::  j      !:
+       INTEGER(iwp)  ::  k      !:
+       INTEGER(iwp)  ::  k_mm   !:
+       INTEGER(iwp)  ::  k_pp   !:
+       INTEGER(iwp)  ::  k_ppp  !:
+       INTEGER(iwp)  ::  tn     !:
+       
+       REAL(wp)     ::  diss_d   !:
+       REAL(wp)     ::  div      !:
+       REAL(wp)     ::  flux_d   !:
+       REAL(wp)     ::  gu       !:
+       REAL(wp)     ::  gv       !:
+       REAL(wp)     ::  u_comp   !:
+       REAL(wp)     ::  v_comp_l !:
+       REAL(wp)     ::  w_comp   !:
+       
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  diss_n !:
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  diss_r !:
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  diss_t !:
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  flux_n !:
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  flux_r !:
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  flux_t !:
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  v_comp !:
 
        gu = 2.0 * u_gtrans
@@ -1631,18 +1761,60 @@
     SUBROUTINE advec_w_ws_ij( i, j, i_omp, tn )
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzu, diss_l_w, diss_s_w, flux_l_w, flux_s_w, tend, u, v, w
+
+       USE constants,                                                          &
+           ONLY:  adv_mom_1, adv_mom_3, adv_mom_5
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzb_max, nzt, wall_flags_0,         &
+                  wall_flags_00
+
+       USE kinds
+       
+       USE statistics,                                                         &
+           ONLY:  hom, sums_ws2_ws_l, weight_substep
 
        IMPLICIT NONE
 
-       INTEGER ::  i, ibit27, ibit28, ibit29, ibit30, ibit31, ibit32, ibit33, &
-                   ibit34, ibit35, i_omp, j, k, k_mm, k_pp, k_ppp, tn
-       REAL    ::  diss_d, div, flux_d, gu, gv, u_comp, v_comp, w_comp
-       REAL, DIMENSION(nzb:nzt+1)  :: diss_n, diss_r, diss_t, flux_n, flux_r, &
-                                      flux_t
+       INTEGER(iwp) ::  i      !:
+       INTEGER(iwp) ::  ibit27 !:
+       INTEGER(iwp) ::  ibit28 !:
+       INTEGER(iwp) ::  ibit29 !:
+       INTEGER(iwp) ::  ibit30 !:
+       INTEGER(iwp) ::  ibit31 !:
+       INTEGER(iwp) ::  ibit32 !:
+       INTEGER(iwp) ::  ibit33 !:
+       INTEGER(iwp) ::  ibit34 !:
+       INTEGER(iwp) ::  ibit35 !:
+       INTEGER(iwp) ::  i_omp  !:
+       INTEGER(iwp) ::  j      !:
+       INTEGER(iwp) ::  k      !:
+       INTEGER(iwp) ::  k_mm   !:
+       INTEGER(iwp) ::  k_pp   !:
+       INTEGER(iwp) ::  k_ppp  !:
+       INTEGER(iwp) ::  tn     !:
+       
+       REAL(wp)    ::  diss_d  !:
+       REAL(wp)    ::  div     !:
+       REAL(wp)    ::  flux_d  !:
+       REAL(wp)    ::  gu      !:
+       REAL(wp)    ::  gv      !:
+       REAL(wp)    ::  u_comp  !:
+       REAL(wp)    ::  v_comp  !:
+       REAL(wp)    ::  w_comp  !:
+       
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  diss_n !:
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  diss_r !:
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  diss_t !:
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  flux_n !:
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  flux_r !:
+       REAL(wp), DIMENSION(nzb:nzt+1)  ::  flux_t !:
 
        gu = 2.0 * u_gtrans
@@ -2027,27 +2199,71 @@
     SUBROUTINE advec_s_ws( sk, sk_char )
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzw, tend, u, v, w
+
+       USE constants,                                                          &
+           ONLY:  adv_sca_1, adv_sca_3, adv_sca_5
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans 
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzb_max, nzt, wall_flags_0
+           
+       USE kinds
+       
+       USE statistics,                                                         &
+           ONLY:  sums_wspts_ws_l, sums_wsqs_ws_l, sums_wssas_ws_l,            &
+                  weight_substep
 
        IMPLICIT NONE
 
-       INTEGER ::  i, ibit0, ibit1, ibit2, ibit3, ibit4, ibit5, ibit6,        &
-                   ibit7, ibit8, j, k, k_mm, k_pp, k_ppp, tn = 0
+       CHARACTER (LEN = *), INTENT(IN)    ::  sk_char !:
+       
+       INTEGER(iwp) ::  i      !:
+       INTEGER(iwp) ::  ibit0  !:
+       INTEGER(iwp) ::  ibit1  !:
+       INTEGER(iwp) ::  ibit2  !:
+       INTEGER(iwp) ::  ibit3  !:
+       INTEGER(iwp) ::  ibit4  !:
+       INTEGER(iwp) ::  ibit5  !:
+       INTEGER(iwp) ::  ibit6  !:
+       INTEGER(iwp) ::  ibit7  !:
+       INTEGER(iwp) ::  ibit8  !:
+       INTEGER(iwp) ::  j      !:
+       INTEGER(iwp) ::  k      !:
+       INTEGER(iwp) ::  k_mm   !:
+       INTEGER(iwp) ::  k_pp   !:
+       INTEGER(iwp) ::  k_ppp  !:
+       INTEGER(iwp) ::  tn = 0 !:
+       
 #if defined( __nopointer )
-       REAL, DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !:
 #else
-       REAL, DIMENSION(:,:,:), POINTER ::  sk
+       REAL(wp), DIMENSION(:,:,:), POINTER ::  sk !:
 #endif
-       REAL ::  diss_d, div, flux_d, u_comp, v_comp
-       REAL, DIMENSION(nzb:nzt)   ::  diss_n, diss_r, diss_t, flux_n, flux_r,  &
-                                      flux_t
-       REAL, DIMENSION(nzb+1:nzt) ::  swap_diss_y_local, swap_flux_y_local
-       REAL, DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local,               &
-                                              swap_flux_x_local
-       CHARACTER (LEN = *), INTENT(IN)    ::  sk_char
+
+       REAL(wp) ::  diss_d !:
+       REAL(wp) ::  div    !:
+       REAL(wp) ::  flux_d !:
+       REAL(wp) ::  u_comp !:
+       REAL(wp) ::  v_comp !:
+       
+       REAL(wp), DIMENSION(nzb:nzt)   ::  diss_n !:
+       REAL(wp), DIMENSION(nzb:nzt)   ::  diss_r !:
+       REAL(wp), DIMENSION(nzb:nzt)   ::  diss_t !:
+       REAL(wp), DIMENSION(nzb:nzt)   ::  flux_n !:
+       REAL(wp), DIMENSION(nzb:nzt)   ::  flux_r !:
+       REAL(wp), DIMENSION(nzb:nzt)   ::  flux_t !:
+       
+       REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_diss_y_local !:
+       REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_flux_y_local !:
+       
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local !:
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_flux_x_local !:
+        
 
 !
@@ -2439,22 +2655,65 @@
     SUBROUTINE advec_s_ws_acc ( sk, sk_char )
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzw, tend, u, v, w
+
+       USE constants,                                                          &
+           ONLY:  adv_sca_1, adv_sca_3, adv_sca_5
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy
+
+       USE indices,                                                            &
+           ONLY:  i_left, i_right, j_north, j_south, nxlg, nxrg, nyng, nysg,   &
+                  nzb, nzb_max, nzt, wall_flags_0
+
+       USE kinds
+       
+!        USE statistics,                                                       &
+!            ONLY:  sums_wspts_ws_l, sums_wsqs_ws_l, sums_wssas_ws_l,          &
+!                   weight_substep
 
        IMPLICIT NONE
 
-       CHARACTER (LEN = *), INTENT(IN)    :: sk_char
-
-       INTEGER ::  i, ibit0, ibit1, ibit2, ibit3, ibit4, ibit5, ibit6,        &
-                   ibit7, ibit8, j, k, k_mm, k_mmm, k_pp, k_ppp, tn = 0
-
-       REAL    :: diss_d, diss_l, diss_n, diss_r, diss_s, diss_t, div, flux_d, &
-                  flux_l, flux_n, flux_r, flux_s, flux_t, u_comp, v_comp
-
-       REAL, INTENT(IN), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  ::  sk
+       CHARACTER (LEN = *), INTENT(IN)    :: sk_char !:
+
+       INTEGER(iwp) ::  i      !:
+       INTEGER(iwp) ::  ibit0  !:
+       INTEGER(iwp) ::  ibit1  !:
+       INTEGER(iwp) ::  ibit2  !:
+       INTEGER(iwp) ::  ibit3  !:
+       INTEGER(iwp) ::  ibit4  !:
+       INTEGER(iwp) ::  ibit5  !:
+       INTEGER(iwp) ::  ibit6  !:
+       INTEGER(iwp) ::  ibit7  !:
+       INTEGER(iwp) ::  ibit8  !:
+       INTEGER(iwp) ::  j      !:
+       INTEGER(iwp) ::  k      !:
+       INTEGER(iwp) ::  k_mm   !:
+       INTEGER(iwp) ::  k_mmm  !:
+       INTEGER(iwp) ::  k_pp   !:
+       INTEGER(iwp) ::  k_ppp  !:
+       INTEGER(iwp) ::  tn = 0 !:
+
+       REAL(wp)    ::  diss_d !:
+       REAL(wp)    ::  diss_l !:
+       REAL(wp)    ::  diss_n !:
+       REAL(wp)    ::  diss_r !:
+       REAL(wp)    ::  diss_s !:
+       REAL(wp)    ::  diss_t !:
+       REAL(wp)    ::  div    !:
+       REAL(wp)    ::  flux_d !:
+       REAL(wp)    ::  flux_l !:
+       REAL(wp)    ::  flux_n !:
+       REAL(wp)    ::  flux_r !:
+       REAL(wp)    ::  flux_s !:
+       REAL(wp)    ::  flux_t !:
+       REAL(wp)    ::  u_comp !:
+       REAL(wp)    ::  v_comp !:
+
+       REAL(wp), INTENT(IN), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  ::  sk !:
 
 !
